package com.mobvcasting.andevvidcap;

import java.io.IOException;

import android.app.Activity;
import android.media.CamcorderProfile;
import android.media.MediaRecorder;
import android.os.Bundle;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.MediaController;
import android.widget.VideoView;

public class AndevVidCap extends Activity implements SurfaceHolder.Callback, OnClickListener {
    
	MediaRecorder recorder;
	SurfaceHolder holder;
	boolean recording = false;
	String videoPath = "/sdcard/videocapture_example.mp4";
	SurfaceView cameraView;
	
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);

        recorder = new MediaRecorder();
        setupRecorder();

		cameraView = (SurfaceView) findViewById(R.id.CameraView);
		holder = cameraView.getHolder();
		holder.addCallback(this);
		holder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
		
		cameraView.setClickable(true);
		cameraView.setOnClickListener(this);
    }

	private void setupRecorder()
	{
        
        recorder.setAudioSource(MediaRecorder.AudioSource.DEFAULT);
        recorder.setVideoSource(MediaRecorder.VideoSource.DEFAULT);        
        
        CamcorderProfile cpHigh = CamcorderProfile
		.get(CamcorderProfile.QUALITY_HIGH);
        recorder.setProfile(cpHigh);
        videoPath = "/sdcard/videocapture_example.mp4";
        recorder.setOutputFile(videoPath);

		recorder.setMaxDuration(50000); // 50 seconds
		recorder.setMaxFileSize(5000000); // Approximately 5 megabytes

	}
	
	public void surfaceCreated(SurfaceHolder holder) {
		recorder.setPreviewDisplay(holder.getSurface());
		try {
			recorder.prepare();
		} catch (IllegalStateException e) {
		} catch (IOException e) {
		}
	}

	public void surfaceChanged(SurfaceHolder holder, int format, int width, int height) {
	}

	public void surfaceDestroyed(SurfaceHolder holder) {
		recorder.release();
	}

	public void onClick(View v) {
		if (recording) {
			recorder.stop();
			recorder.release();
			//setupRecorder();
			
			cameraView.setVisibility(View.INVISIBLE); 
			
			VideoView vv = (VideoView) this.findViewById(R.id.VideoView01);
			vv.setVideoPath(videoPath);
			vv.setMediaController(new MediaController(this));

			vv.start();
			
			recording = false;
		} else {
			recording = true;
			recorder.start();
		}		
	}	
	
	
}